init/clone: remove short option -L and document --separate-git-dir
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
b13fd5c1 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
98fcf840 17. git-parse-remote
70c7ac22
LH
18require_work_tree
19
5c08dbbd 20command=
ecda0723 21branch=
d27b876b 22force=
d92a3959 23reference=
70c7ac22 24cached=
48bb3033
GP
25recursive=
26init=
1c244f6e 27files=
31ca3ac3 28nofetch=
32948425 29update=
15fc56a8 30prefix=
70c7ac22 31
f31a522a
ML
32# Resolve relative url by appending to parent's url
33resolve_relative_url ()
34{
98fcf840 35 remote=$(get_default_remote)
8e7e6f39
ML
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
f31a522a 38 url="$1"
99b120af 39 remoteurl=${remoteurl%/}
ea640cc6 40 sep=/
f31a522a
ML
41 while test -n "$url"
42 do
43 case "$url" in
44 ../*)
45 url="${url#../}"
ea640cc6
TR
46 case "$remoteurl" in
47 */*)
48 remoteurl="${remoteurl%/*}"
49 ;;
50 *:*)
51 remoteurl="${remoteurl%:*}"
52 sep=:
53 ;;
54 *)
55 die "cannot strip one component off url '$remoteurl'"
56 ;;
57 esac
f31a522a
ML
58 ;;
59 ./*)
60 url="${url#./}"
61 ;;
62 *)
63 break;;
64 esac
65 done
ea640cc6 66 echo "$remoteurl$sep${url%/}"
f31a522a
ML
67}
68
a7b3269c
DA
69#
70# Get submodule info for registered submodules
71# $@ = path to limit submodule list
72#
73module_list()
74{
313ee0d6
NMC
75 git ls-files --error-unmatch --stage -- "$@" |
76 perl -e '
77 my %unmerged = ();
78 my ($null_sha1) = ("0" x 40);
79 while (<STDIN>) {
80 chomp;
81 my ($mode, $sha1, $stage, $path) =
82 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
83 next unless $mode eq "160000";
84 if ($stage ne "0") {
85 if (!$unmerged{$path}++) {
86 print "$mode $null_sha1 U\t$path\n";
87 }
88 next;
89 }
90 print "$_\n";
91 }
92 '
a7b3269c
DA
93}
94
941987a5
LH
95#
96# Map submodule path to submodule name
97#
98# $1 = path
99#
100module_name()
101{
537601ac 102 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
fe22e542 103 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 104 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 105 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
941987a5
LH
106 test -z "$name" &&
107 die "No submodule mapping found in .gitmodules for path '$path'"
108 echo "$name"
109}
33aa6fff
LH
110
111#
112# Clone a submodule
113#
23a485e3 114# Prior to calling, cmd_update checks that a possibly existing
ecda0723 115# path is not a git repository.
23a485e3 116# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
117# since it is the location of a new submodule.
118#
33aa6fff
LH
119module_clone()
120{
121 path=$1
122 url=$2
d92a3959 123 reference="$3"
33aa6fff 124
d92a3959
MT
125 if test -n "$reference"
126 then
127 git-clone "$reference" -n "$url" "$path"
128 else
129 git-clone -n "$url" "$path"
130 fi ||
941987a5 131 die "Clone of '$url' into submodule path '$path' failed"
33aa6fff
LH
132}
133
ecda0723
SV
134#
135# Add a new submodule to the working tree, .gitmodules and the index
136#
ec05df35 137# $@ = repo path
ecda0723
SV
138#
139# optional branch is stored in global branch variable
140#
23a485e3 141cmd_add()
ecda0723 142{
5c08dbbd
JH
143 # parse $args after "submodule ... add".
144 while test $# -ne 0
145 do
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
151 ;;
d27b876b
JL
152 -f | --force)
153 force=$1
154 ;;
5c08dbbd 155 -q|--quiet)
2e6a30ef 156 GIT_QUIET=1
5c08dbbd 157 ;;
d92a3959
MT
158 --reference)
159 case "$2" in '') usage ;; esac
160 reference="--reference=$2"
161 shift
162 ;;
163 --reference=*)
164 reference="$1"
165 shift
166 ;;
5c08dbbd
JH
167 --)
168 shift
169 break
170 ;;
171 -*)
172 usage
173 ;;
174 *)
175 break
176 ;;
177 esac
178 shift
179 done
180
ecda0723
SV
181 repo=$1
182 path=$2
183
1414e578
JL
184 if test -z "$path"; then
185 path=$(echo "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
187 fi
188
ec05df35 189 if test -z "$repo" -o -z "$path"; then
ecda0723
SV
190 usage
191 fi
192
ec05df35
ML
193 # assure repo is absolute or relative to parent
194 case "$repo" in
195 ./*|../*)
196 # dereference source url relative to parent's url
197 realrepo=$(resolve_relative_url "$repo") || exit
198 ;;
199 *:*|/*)
200 # absolute url
201 realrepo=$repo
202 ;;
203 *)
204 die "repo URL: '$repo' must be absolute or begin with ./|../"
205 ;;
206 esac
207
db75ada5
MG
208 # normalize path:
209 # multiple //; leading ./; /./; /../; trailing /
210 path=$(printf '%s/\n' "$path" |
211 sed -e '
212 s|//*|/|g
213 s|^\(\./\)*||
214 s|/\./|/|g
215 :start
216 s|\([^/]*\)/\.\./||
217 tstart
218 s|/*$||
219 ')
5be60078 220 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
ecda0723
SV
221 die "'$path' already exists in the index"
222
d27b876b
JL
223 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
224 then
225 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
226 echo >&2 $path &&
227 echo >&2 "Use -f if you really want to add it."
228 exit 1
229 fi
230
d4264ca3
ML
231 # perhaps the path exists and is already a git repo, else clone it
232 if test -e "$path"
233 then
e9656473 234 if test -d "$path"/.git -o -f "$path"/.git
d4264ca3
ML
235 then
236 echo "Adding existing repo at '$path' to the index"
237 else
238 die "'$path' already exists and is not a valid git repo"
239 fi
c2f93917
ML
240
241 case "$repo" in
242 ./*|../*)
243 url=$(resolve_relative_url "$repo") || exit
244 ;;
245 *)
246 url="$repo"
247 ;;
248 esac
249 git config submodule."$path".url "$url"
d4264ca3 250 else
d4264ca3 251
d92a3959 252 module_clone "$path" "$realrepo" "$reference" || exit
ea10b60c 253 (
74ae1419 254 clear_local_git_env
ea10b60c
BJ
255 cd "$path" &&
256 # ash fails to wordsplit ${branch:+-b "$branch"...}
257 case "$branch" in
258 '') git checkout -f -q ;;
502dc5b6 259 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c
BJ
260 esac
261 ) || die "Unable to checkout submodule '$path'"
d4264ca3
ML
262 fi
263
d27b876b 264 git add $force "$path" ||
ecda0723
SV
265 die "Failed to add submodule '$path'"
266
a5099bb4
IY
267 git config -f .gitmodules submodule."$path".path "$path" &&
268 git config -f .gitmodules submodule."$path".url "$repo" &&
31991b02 269 git add --force .gitmodules ||
ecda0723
SV
270 die "Failed to register submodule '$path'"
271}
272
19a31f9c
ML
273#
274# Execute an arbitrary command sequence in each checked out
275# submodule
276#
277# $@ = command to execute
278#
279cmd_foreach()
280{
1d5bec8b
JH
281 # parse $args after "submodule ... foreach".
282 while test $# -ne 0
283 do
284 case "$1" in
285 -q|--quiet)
286 GIT_QUIET=1
287 ;;
15fc56a8
JH
288 --recursive)
289 recursive=1
290 ;;
1d5bec8b
JH
291 -*)
292 usage
293 ;;
294 *)
295 break
296 ;;
297 esac
298 shift
299 done
300
f030c96d
ÆAB
301 toplevel=$(pwd)
302
a7b3269c 303 module_list |
19a31f9c
ML
304 while read mode sha1 stage path
305 do
306 if test -e "$path"/.git
307 then
15fc56a8 308 say "Entering '$prefix$path'"
1e7f2aad 309 name=$(module_name "$path")
15fc56a8
JH
310 (
311 prefix="$prefix$path/"
74ae1419 312 clear_local_git_env
15fc56a8
JH
313 cd "$path" &&
314 eval "$@" &&
315 if test -n "$recursive"
316 then
317 cmd_foreach "--recursive" "$@"
318 fi
319 ) ||
19a31f9c
ML
320 die "Stopping at '$path'; script returned non-zero status."
321 fi
322 done
323}
324
70c7ac22 325#
211b7f19 326# Register submodules in .git/config
70c7ac22
LH
327#
328# $@ = requested paths (default to all)
329#
23a485e3 330cmd_init()
70c7ac22 331{
5c08dbbd
JH
332 # parse $args after "submodule ... init".
333 while test $# -ne 0
334 do
335 case "$1" in
336 -q|--quiet)
2e6a30ef 337 GIT_QUIET=1
5c08dbbd
JH
338 ;;
339 --)
340 shift
341 break
342 ;;
343 -*)
344 usage
345 ;;
346 *)
347 break
348 ;;
349 esac
350 shift
351 done
352
a7b3269c 353 module_list "$@" |
70c7ac22
LH
354 while read mode sha1 stage path
355 do
211b7f19 356 # Skip already registered paths
941987a5 357 name=$(module_name "$path") || exit
5be60078 358 url=$(git config submodule."$name".url)
211b7f19 359 test -z "$url" || continue
70c7ac22 360
a5099bb4 361 url=$(git config -f .gitmodules submodule."$name".url)
70c7ac22 362 test -z "$url" &&
941987a5 363 die "No url found for submodule path '$path' in .gitmodules"
70c7ac22 364
f31a522a
ML
365 # Possibly a url relative to parent
366 case "$url" in
367 ./*|../*)
8e7e6f39 368 url=$(resolve_relative_url "$url") || exit
f31a522a
ML
369 ;;
370 esac
371
5be60078 372 git config submodule."$name".url "$url" ||
941987a5 373 die "Failed to register url for submodule path '$path'"
70c7ac22 374
32948425
JH
375 upd="$(git config -f .gitmodules submodule."$name".update)"
376 test -z "$upd" ||
377 git config submodule."$name".update "$upd" ||
378 die "Failed to register update mode for submodule path '$path'"
ca2cedba 379
941987a5 380 say "Submodule '$name' ($url) registered for path '$path'"
70c7ac22
LH
381 done
382}
383
384#
211b7f19 385# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
386#
387# $@ = requested paths (default to all)
388#
23a485e3 389cmd_update()
70c7ac22 390{
5c08dbbd 391 # parse $args after "submodule ... update".
98dbe63d 392 orig_flags=
5c08dbbd
JH
393 while test $# -ne 0
394 do
395 case "$1" in
396 -q|--quiet)
2e6a30ef 397 GIT_QUIET=1
5c08dbbd 398 ;;
be4d2c83 399 -i|--init)
d92a3959 400 init=1
be4d2c83 401 ;;
31ca3ac3 402 -N|--no-fetch)
31ca3ac3
FF
403 nofetch=1
404 ;;
ca2cedba 405 -r|--rebase)
32948425 406 update="rebase"
ca2cedba 407 ;;
d92a3959
MT
408 --reference)
409 case "$2" in '') usage ;; esac
410 reference="--reference=$2"
98dbe63d
KB
411 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
412 shift
d92a3959
MT
413 ;;
414 --reference=*)
415 reference="$1"
d92a3959 416 ;;
42b49178 417 -m|--merge)
42b49178
JH
418 update="merge"
419 ;;
b13fd5c1 420 --recursive)
b13fd5c1
JH
421 recursive=1
422 ;;
5c08dbbd
JH
423 --)
424 shift
425 break
426 ;;
427 -*)
428 usage
429 ;;
430 *)
431 break
432 ;;
433 esac
98dbe63d
KB
434 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
435 shift
5c08dbbd
JH
436 done
437
d92a3959
MT
438 if test -n "$init"
439 then
440 cmd_init "--" "$@" || return
441 fi
442
1b4735d9 443 cloned_modules=
a7b3269c 444 module_list "$@" |
70c7ac22
LH
445 while read mode sha1 stage path
446 do
313ee0d6
NMC
447 if test "$stage" = U
448 then
449 echo >&2 "Skipping unmerged submodule $path"
450 continue
451 fi
941987a5 452 name=$(module_name "$path") || exit
5be60078 453 url=$(git config submodule."$name".url)
32948425 454 update_module=$(git config submodule."$name".update)
211b7f19 455 if test -z "$url"
70c7ac22
LH
456 then
457 # Only mention uninitialized submodules when its
458 # path have been specified
459 test "$#" != "0" &&
989206f5 460 say "Submodule path '$path' not initialized" &&
be4d2c83 461 say "Maybe you want to use 'update --init'?"
211b7f19
LH
462 continue
463 fi
464
ba88a1fe 465 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19 466 then
d92a3959 467 module_clone "$path" "$url" "$reference"|| exit
1b4735d9 468 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
469 subsha1=
470 else
74ae1419 471 subsha1=$(clear_local_git_env; cd "$path" &&
5be60078 472 git rev-parse --verify HEAD) ||
941987a5 473 die "Unable to find current revision in submodule path '$path'"
70c7ac22 474 fi
211b7f19 475
32948425 476 if ! test -z "$update"
ca2cedba 477 then
32948425 478 update_module=$update
ca2cedba
PH
479 fi
480
70c7ac22
LH
481 if test "$subsha1" != "$sha1"
482 then
b9b378a0
PY
483 force=
484 if test -z "$subsha1"
485 then
486 force="-f"
487 fi
31ca3ac3
FF
488
489 if test -z "$nofetch"
490 then
e5f522d6
JL
491 # Run fetch only if $sha1 isn't present or it
492 # is not reachable from a ref.
74ae1419 493 (clear_local_git_env; cd "$path" &&
e5f522d6
JL
494 ((rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
495 test -z "$rev") || git-fetch)) ||
31ca3ac3
FF
496 die "Unable to fetch in submodule path '$path'"
497 fi
498
1b4735d9
SO
499 # Is this something we just cloned?
500 case ";$cloned_modules;" in
501 *";$name;"*)
502 # then there is no local change to integrate
503 update_module= ;;
504 esac
505
32948425
JH
506 case "$update_module" in
507 rebase)
508 command="git rebase"
ca2cedba
PH
509 action="rebase"
510 msg="rebased onto"
32948425 511 ;;
42b49178
JH
512 merge)
513 command="git merge"
514 action="merge"
515 msg="merged in"
516 ;;
32948425
JH
517 *)
518 command="git checkout $force -q"
ca2cedba
PH
519 action="checkout"
520 msg="checked out"
32948425
JH
521 ;;
522 esac
70c7ac22 523
74ae1419 524 (clear_local_git_env; cd "$path" && $command "$sha1") ||
ca2cedba
PH
525 die "Unable to $action '$sha1' in submodule path '$path'"
526 say "Submodule path '$path': $msg '$sha1'"
70c7ac22 527 fi
b13fd5c1
JH
528
529 if test -n "$recursive"
530 then
98dbe63d 531 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
b13fd5c1
JH
532 die "Failed to recurse into submodule path '$path'"
533 fi
70c7ac22
LH
534 done
535}
536
bffe71f4
EM
537set_name_rev () {
538 revname=$( (
74ae1419 539 clear_local_git_env
bffe71f4 540 cd "$1" && {
5be60078
JH
541 git describe "$2" 2>/dev/null ||
542 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
543 git describe --contains "$2" 2>/dev/null ||
544 git describe --all --always "$2"
bffe71f4
EM
545 }
546 ) )
547 test -z "$revname" || revname=" ($revname)"
548}
28f9af5d
PY
549#
550# Show commit summary for submodules in index or working tree
551#
552# If '--cached' is given, show summary between index and given commit,
553# or between working tree and given commit
554#
555# $@ = [commit (default 'HEAD'),] requested paths (default all)
556#
557cmd_summary() {
f2dc06a3 558 summary_limit=-1
d0f64dd4 559 for_status=
1c244f6e 560 diff_cmd=diff-index
f2dc06a3 561
28f9af5d
PY
562 # parse $args after "submodule ... summary".
563 while test $# -ne 0
564 do
565 case "$1" in
566 --cached)
567 cached="$1"
568 ;;
1c244f6e
JL
569 --files)
570 files="$1"
571 ;;
d0f64dd4
PY
572 --for-status)
573 for_status="$1"
574 ;;
f2dc06a3
PY
575 -n|--summary-limit)
576 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
577 then
578 :
579 else
580 usage
581 fi
582 shift
583 ;;
28f9af5d
PY
584 --)
585 shift
586 break
587 ;;
588 -*)
589 usage
590 ;;
591 *)
592 break
593 ;;
594 esac
595 shift
596 done
bffe71f4 597
f2dc06a3
PY
598 test $summary_limit = 0 && return
599
3deea89c 600 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
601 then
602 head=$rev
caa9c3ca 603 test $# = 0 || shift
3deea89c
JH
604 elif test -z "$1" -o "$1" = "HEAD"
605 then
14e940d7
JH
606 # before the first commit: compare with an empty tree
607 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 608 test -z "$1" || shift
28f9af5d 609 else
3deea89c 610 head="HEAD"
28f9af5d
PY
611 fi
612
1c244f6e
JL
613 if [ -n "$files" ]
614 then
615 test -n "$cached" &&
616 die "--cached cannot be used with --files"
617 diff_cmd=diff-files
618 head=
619 fi
620
28f9af5d
PY
621 cd_to_toplevel
622 # Get modified modules cared by user
18076502 623 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 624 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
625 while read mod_src mod_dst sha1_src sha1_dst status name
626 do
627 # Always show modules deleted or type-changed (blob<->module)
628 test $status = D -o $status = T && echo "$name" && continue
629 # Also show added or modified modules which are checked out
630 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
631 echo "$name"
632 done
633 )
1cb639e6 634
d0f64dd4
PY
635 test -z "$modules" && return
636
18076502 637 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 638 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
639 cut -c2- |
640 while read mod_src mod_dst sha1_src sha1_dst status name
641 do
642 if test -z "$cached" &&
643 test $sha1_dst = 0000000000000000000000000000000000000000
644 then
645 case "$mod_dst" in
646 160000)
647 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
648 ;;
649 100644 | 100755 | 120000)
650 sha1_dst=$(git hash-object $name)
651 ;;
652 000000)
653 ;; # removed
654 *)
655 # unexpected type
656 echo >&2 "unexpected mode $mod_dst"
657 continue ;;
658 esac
659 fi
660 missing_src=
661 missing_dst=
662
663 test $mod_src = 160000 &&
30353a40 664 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
665 missing_src=t
666
667 test $mod_dst = 160000 &&
30353a40 668 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 669 missing_dst=t
bffe71f4 670
1cb639e6
PY
671 total_commits=
672 case "$missing_src,$missing_dst" in
673 t,)
674 errmsg=" Warn: $name doesn't contain commit $sha1_src"
675 ;;
676 ,t)
677 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
678 ;;
679 t,t)
680 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
681 ;;
682 *)
683 errmsg=
684 total_commits=$(
685 if test $mod_src = 160000 -a $mod_dst = 160000
686 then
687 range="$sha1_src...$sha1_dst"
688 elif test $mod_src = 160000
689 then
690 range=$sha1_src
691 else
692 range=$sha1_dst
693 fi
694 GIT_DIR="$name/.git" \
b0e621ad 695 git rev-list --first-parent $range -- | wc -l
1cb639e6 696 )
eed35595 697 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
698 ;;
699 esac
700
701 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
702 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
703 if test $status = T
704 then
705 if test $mod_dst = 160000
706 then
707 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
708 else
709 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
710 fi
711 else
712 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
713 fi
714 if test -n "$errmsg"
715 then
716 # Don't give error msg for modification whose dst is not submodule
717 # i.e. deleted or changed to blob
718 test $mod_dst = 160000 && echo "$errmsg"
719 else
720 if test $mod_src = 160000 -a $mod_dst = 160000
721 then
f2dc06a3
PY
722 limit=
723 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 724 GIT_DIR="$name/.git" \
f2dc06a3 725 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
726 --first-parent $sha1_src...$sha1_dst
727 elif test $mod_dst = 160000
728 then
729 GIT_DIR="$name/.git" \
730 git log --pretty='format: > %s' -1 $sha1_dst
731 else
732 GIT_DIR="$name/.git" \
733 git log --pretty='format: < %s' -1 $sha1_src
734 fi
735 echo
736 fi
737 echo
d0f64dd4
PY
738 done |
739 if test -n "$for_status"; then
f17a5d34
JL
740 if [ -n "$files" ]; then
741 echo "# Submodules changed but not updated:"
742 else
743 echo "# Submodule changes to be committed:"
744 fi
d0f64dd4
PY
745 echo "#"
746 sed -e 's|^|# |' -e 's|^# $|#|'
747 else
748 cat
749 fi
28f9af5d 750}
70c7ac22 751#
941987a5 752# List all submodules, prefixed with:
70c7ac22
LH
753# - submodule not initialized
754# + different revision checked out
755#
756# If --cached was specified the revision in the index will be printed
757# instead of the currently checked out revision.
758#
759# $@ = requested paths (default to all)
760#
23a485e3 761cmd_status()
70c7ac22 762{
5c08dbbd 763 # parse $args after "submodule ... status".
98dbe63d 764 orig_flags=
5c08dbbd
JH
765 while test $# -ne 0
766 do
767 case "$1" in
768 -q|--quiet)
2e6a30ef 769 GIT_QUIET=1
5c08dbbd
JH
770 ;;
771 --cached)
772 cached=1
773 ;;
64b19ffe
JH
774 --recursive)
775 recursive=1
776 ;;
5c08dbbd
JH
777 --)
778 shift
779 break
780 ;;
781 -*)
782 usage
783 ;;
784 *)
785 break
786 ;;
787 esac
98dbe63d 788 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
789 shift
790 done
791
a7b3269c 792 module_list "$@" |
70c7ac22
LH
793 while read mode sha1 stage path
794 do
941987a5 795 name=$(module_name "$path") || exit
5be60078 796 url=$(git config submodule."$name".url)
64b19ffe 797 displaypath="$prefix$path"
313ee0d6
NMC
798 if test "$stage" = U
799 then
800 say "U$sha1 $displaypath"
801 continue
802 fi
ba88a1fe 803 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22 804 then
64b19ffe 805 say "-$sha1 $displaypath"
70c7ac22
LH
806 continue;
807 fi
41c7c1bd 808 set_name_rev "$path" "$sha1"
18076502 809 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
70c7ac22 810 then
64b19ffe 811 say " $sha1 $displaypath$revname"
70c7ac22
LH
812 else
813 if test -z "$cached"
814 then
74ae1419 815 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 816 set_name_rev "$path" "$sha1"
70c7ac22 817 fi
64b19ffe
JH
818 say "+$sha1 $displaypath$revname"
819 fi
820
821 if test -n "$recursive"
822 then
823 (
824 prefix="$displaypath/"
74ae1419 825 clear_local_git_env
64b19ffe 826 cd "$path" &&
a7eff1a8 827 eval cmd_status "$orig_args"
64b19ffe
JH
828 ) ||
829 die "Failed to recurse into submodule path '$path'"
70c7ac22
LH
830 fi
831 done
832}
2327f61e
DA
833#
834# Sync remote urls for submodules
835# This makes the value for remote.$remote.url match the value
836# specified in .gitmodules.
837#
838cmd_sync()
839{
840 while test $# -ne 0
841 do
842 case "$1" in
843 -q|--quiet)
2e6a30ef 844 GIT_QUIET=1
2327f61e
DA
845 shift
846 ;;
847 --)
848 shift
849 break
850 ;;
851 -*)
852 usage
853 ;;
854 *)
855 break
856 ;;
857 esac
858 done
859 cd_to_toplevel
860 module_list "$@" |
861 while read mode sha1 stage path
862 do
863 name=$(module_name "$path")
864 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
865
866 # Possibly a url relative to parent
867 case "$url" in
868 ./*|../*)
869 url=$(resolve_relative_url "$url") || exit
870 ;;
871 esac
872
33f072f8
AK
873 say "Synchronizing submodule url for '$name'"
874 git config submodule."$name".url "$url"
875
2327f61e
DA
876 if test -e "$path"/.git
877 then
878 (
74ae1419 879 clear_local_git_env
2327f61e
DA
880 cd "$path"
881 remote=$(get_default_remote)
2327f61e
DA
882 git config remote."$remote".url "$url"
883 )
884 fi
885 done
886}
70c7ac22 887
5c08dbbd
JH
888# This loop parses the command line arguments to find the
889# subcommand name to dispatch. Parsing of the subcommand specific
890# options are primarily done by the subcommand implementations.
891# Subcommand specific options such as --branch and --cached are
892# parsed here as well, for backward compatibility.
893
894while test $# != 0 && test -z "$command"
70c7ac22
LH
895do
896 case "$1" in
2327f61e 897 add | foreach | init | update | status | summary | sync)
5c08dbbd 898 command=$1
70c7ac22
LH
899 ;;
900 -q|--quiet)
2e6a30ef 901 GIT_QUIET=1
70c7ac22 902 ;;
ecda0723
SV
903 -b|--branch)
904 case "$2" in
905 '')
906 usage
907 ;;
908 esac
909 branch="$2"; shift
910 ;;
70c7ac22 911 --cached)
28f9af5d 912 cached="$1"
70c7ac22
LH
913 ;;
914 --)
915 break
916 ;;
917 -*)
918 usage
919 ;;
920 *)
921 break
922 ;;
923 esac
924 shift
925done
926
5c08dbbd
JH
927# No command word defaults to "status"
928test -n "$command" || command=status
929
930# "-b branch" is accepted only by "add"
931if test -n "$branch" && test "$command" != add
932then
ecda0723 933 usage
5c08dbbd
JH
934fi
935
28f9af5d
PY
936# "--cached" is accepted only by "status" and "summary"
937if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 938then
70c7ac22 939 usage
5c08dbbd
JH
940fi
941
942"cmd_$command" "$@"